#include <hmg.ch>
#include "rddleto.ch"

REQUEST LETO
REQUEST DBFCDX

Function Main

  PUBLIC cDirTrab:="", ARQLOCOK, ARQALIAS,ARQNIND,ARQ1,ARQ               // seta rea de trabalho, modificando essa varivel, no  necessrio mudar o resto do cdigo
  PUBLIC pcFileIni:="config.ini"              // Nome do arquibo ini
  PUBLIC pcHostName:=""                       // Varivel global para pegar o valor do campo no arquivo ini

  RDDSETDEFAULT("LETO")
  DBSETDRIVER("DBFCDX")

  cDirTrab:=ini_le() // recebe string de conexo
  
  if leto_connect(cDirTrab) < 0 // conceta com o servidor letodb
     msgStop("Erro ao tentar conectar com o servidor LetoDBf", "Error")
     quit
  endif

  if !leto_File("ubuntu.dbf")
     createtables()
  else
     listData()
  endIf

  Load Window Main
  Main.Center
  Main.Activate
  
  Main.Browse_1.Value:=ub->(RecNo())

Return

/*
** Abre tabela
*/
Function listData()

  Sele 0                                      // Arquivo Identificador da Area de Trabalho.
  ARQ:=cDirTrab+'ubuntu'
  ARQ1:=cDirTrab+'ubuntu.cdx'
  ARQNIND:=1
  ARQALIAS:='ub'
  RDUSE()
  IF ARQLOCOK = 'F' ; dbCloseAll() ; RETURN ; ENDIF

  Sele ub

  dbSetOrder(1)                               // Nome Fornecedor.
  dbGoTop()

Return

/*
** Cria tabela na base de dados
*/
Function createtables()
  LOCAL arquivo:="ubuntu.dbf", aStruct := { { "Nome",   "C", 80, 0 }, ;
                                            { "Email",  "C", 80, 0 }, ;
                                            { "CEP",    "C",  9, 0 }, ;
                                            { "Rua",    "C", 80, 0 }, ;
                                            { "Numero", "N",  15, 0 } }

  REQUEST LETO

  dbCreate( arquivo, aStruct, "LETO", .T., "ub" )

  if leto_File(arquivo)

  
    Index on Nome TAG nome TO 'ubuntu.cdx'


  else
      msgStop("Erro ao criar arquivo cdx", "Erro")
  endif

Return